<?php



function getDebutHTML(): string {
    return "<!doctype html>
        <html lang=\"fr\">
        <head>
          <meta charset=\"utf-8\">
          <title>appli crud</title>
            <!--  <link rel=\"stylesheet\" href=\"style.css\"> -->
            <!--  <script src=\"script.js\"></script> -->
        </head>
        <body>";
}

function getFinHTML(): string {
    return "<!-- contenu -->
</body>
</html>
";
}


    // initialisation de la connexion via l'instance de MyPDO
$myPDOAppellation = new MyPDO($_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['password'], 'Appellation');

    // initialisation du générateur de vues HTML
$vue = new VueAppellation();

    // initialisation des chaînes à afficher
$contenu = "";
$message = "";

    // traitement des différentes actions possibles

if (isset($_GET['action']))
    switch ($_GET['action']) {
        case 'read':
            $Appellation = $myPDOAppellation->get('id_Appellation', $_GET['id_Appellation']);
            $contenu .= $vue->getHTML4Appellation($Appellation);
            $_SESSION['etat'] = 'lecture';
            break;
        case 'create':
            $nbAppellation = $myPDOAppellation->count();
            $contenu .= $vue->getFormulaire4Appellation(array('id_Appellation' => array ('type'=>'number', 'default'=> $myPDOAppellation->getMax("id_appellation")+1),'nom_Appellation' => 'text', 'categorie_Appellation' => 'text'));
            $_SESSION['etat'] = 'création';
            break;
        case 'update':
            $Appellation = $myPDOAppellation->get('id_Appellation',$_GET['id_Appellation']);
            $contenu .= $vue->getFormulaire4Appellation(array('id_Appellation'=>array('type'=>'number','default'=>$Appellation->getIdAppellation()),
                'nom_Appellation'=>array('type'=>'text','default'=>$Appellation->getNomAppellation()),
                'categorie_Appellation'=>array('type'=>'text','default'=>$Appellation->getCategorieAppellation())));
            $_SESSION['etat'] = 'modification';
            break;
        case 'delete':
            $myPDOAppellation->delete(array('id_Appellation'=>$_GET['id_Appellation']));
            $_SESSION['etat'] = 'suppression';
            break;
        default:
            $message .= "<p>Action ".$_GET['action']." non implémentée.</p>\n";
    }

else
    if (isset($_SESSION['etat']))
        switch($_SESSION['etat']) {
            case 'création':
                $myPDOAppellation->insert(array('id_Appellation'=>$_GET['id_Appellation'],'nom_Appellation'=>$_GET['nom_Appellation'], 'categorie_Appellation'=>$_GET['categorie_Appellation']));
                $_SESSION['etat'] = 'créé';
                break;
            case 'modification':
                $myPDOAppellation->update('id_Appellation', array('id_Appellation'=>$_GET['id_Appellation'], 'nom_Appellation'=>$_GET['nom_Appellation'], 'categorie_Appellation'=>$_GET['categorie_Appellation']));
                $_SESSION['etat'] = 'modifié';
                break;
            case 'suppression':
                $_SESSION['etat']= 'supprimé';
                break;
            case 'créé':
            case 'modifié':
            case 'supprimé':
            default:
                $_SESSION['etat'] = 'neutre';
        }


    // affichage du nombre total d'appellations :
$nbAppellation = $myPDOAppellation->count();
$message .= "<p>La table Appellation contient ".$nbAppellation." enregistrements.</p>\n";

    // sélection/modification/suppression/ d'une appellation

    $contenu .=
        "<form action='?' method='GET'>
            <select name='action'>
            <option value='read'>Visualiser une appellation</option>
            <option value='update'>Modifier</option>
            <option value='delete'>Supprimer</option>
            </select>
            <input type='number' min='1' max='".$myPDOAppellation->getMax("id_appellation")."' name='id_Appellation'/>
            <input type='submit' name='envoi' value='Go' />
        </form>\n";


    // création d'une nouvelle appellation
    // Attention suppose que le nombre d'appellations présentent correspond au dernier identifiant attribué...
$contenu .="<p><a href='?action=create'>Créer une appellation ";
$contenu .= $myPDOAppellation->getMax("id_appellation")+1;
$contenu .= "</a> </p>";

    // récupération et affichage de la liste des appellations avec liens vers édition/suppresion

$lesAppellations = $myPDOAppellation->getAll();
$contenu .= $vue->getAllAppellation($lesAppellations);

    // Production de la page HTML
echo getDebutHTML();
echo $message;
echo $contenu;
echo getFinHTML();
