<?php

function getDebutHTML(): string {
    return "<!doctype html>
        <html lang=\"fr\">
        <head>
          <meta charset=\"utf-8\">
          <title>appli crud</title>
            <!--  <link rel=\"stylesheet\" href=\"style.css\"> -->
            <!--  <script src=\"script.js\"></script> -->
        </head>
        <body>";
}

function getFinHTML(): string {
    return "<!-- contenu -->
</body>
</html>
";
}


    // initialisation de la connexion via l'instance de MyPDO
$myPDOquantite = new MyPDO($_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['password'], 'quantite');

    // initialisation du générateur de vues HTML
$vue = new VueQuantite();

    // initialisation des chaînes à afficher
$contenu = "";
$message = "";

    // traitement des différentes actions possibles

if (isset($_GET['action']))
    switch ($_GET['action']) {
        case 'read':
            $quantite = $myPDOquantite->getQte($_GET['nom_bouteille'],$_GET['volume_bouteille'],$_GET['millesime_bouteille']);
            $contenu .= $vue->getHTML4Quantite($quantite);
            $_SESSION['etat'] = 'lecture';
            break;
        case 'update':
            $quantite = $myPDOquantite->getQte($_GET['nom_bouteille'],$_GET['volume_bouteille'],$_GET['millesime_bouteille']);
            $contenu .= $vue->getFormulaire4quantite(array('nom_bouteille'=>array('type'=>'text','default'=>$quantite->getNom_bouteille()),
                'volume_bouteille'=>array('type'=>'number','default'=>$quantite->getVolume_bouteille()),
                'millesime_bouteille'=>array('type'=>'number','default'=>$quantite->getMillesime_bouteille()),
                'qte_bouteille'=>array('type'=>'number','default'=>$quantite->getQte_bouteille())));
            $_SESSION['etat'] = 'modification';
            break;
        default:
            $message .= "<p>Action ".$_GET['action']." non implémentée.</p>\n";
    }

else
    if (isset($_SESSION['etat']))
        switch($_SESSION['etat']) {
            case 'modification':
                $myPDOquantite->update('nom_bouteille', array('nom_bouteille'=>$_GET['nom_bouteille'],'volume_bouteille'=>$_GET['volume_bouteille'], 'millesime_bouteille'=>$_GET['millesime_bouteille'], 'qte_bouteille'=>$_GET['qte_bouteille']));
                $_SESSION['etat'] = 'modifié';
                break;
            case 'modifié':
            default:
                $_SESSION['etat'] = 'neutre';
        }


    // affichage du nombre total de quantites :
$nbquantite = $myPDOquantite->count();
$message .= "<p>La table quantite contient ".$nbquantite." enregistrements.</p>\n";

    // sélection/modification/suppression/ d'une quantite

    $contenu .=
        "<form action='?' method='GET'>
            <select name='action'>
            <option value='read'>Visualiser une quantite</option>
            </select>
            <input type='text' name='nom_bouteille'/>
            <select name='volume_bouteille'>"
            .$vue->getAllVolumes().
            "</select>
            <input type='number' name='millesime_bouteille'/>
            <input type='submit' name='envoi' value='Go' />
        </form>\n";


    // récupération et affichage de la liste des quantites avec liens vers édition/suppresion

$lesquantites = $myPDOquantite->getAll();
$contenu .= $vue->getAllQuantite($lesquantites);

    // Production de la page HTML
echo getDebutHTML();
echo $message;
echo $contenu;
echo getFinHTML();
