<?php

include "../Tables/Appellation.php";
include "../MyPDO.php";
include "../bdd.php";

class AppellationIterator implements Iterator, Countable {
    protected $id_appellation =1;
    private MyPDO $myPDOAppellation;

    public function __construct()
    {
        $this->myPDOAppellation = new MyPDO($_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['password'], 'Appellation');
    }

    public function count(){
        return $this->myPDOAppellation->count();
    }

    public function current(){
        return $this->myPDOAppellation->get("id_appellation",$this->id_appellation);
    }

    public function key(){
        return $this->id_appellation;
    }

    public function next(){
        $val = $this->myPDOAppellation->get("id_appellation",0);
        $this->id_appellation++;
        if( $this->id_appellation < $this->myPDOAppellation->getMax("id_appellation") && $this->myPDOAppellation->get("id_appellation",$this->id_appellation) == $val )
            $this->next();  
    }

    public function rewind(){
        $this->id_appellation = 1;
    }

    public function valid(){
        return $this->id_appellation > 0 && $this->id_appellation <= $this->myPDOAppellation->getMax("id_appellation");
    }
}
?>