<?php

    include "../Tables/Bouteille.php";
    include "../MyPDO.php";
    include "../bdd.php";

class BouteilleIterator implements Iterator, Countable {
    protected $id_bouteille = 1;
    private MyPDO $myPDOBouteille;

    public function __construct()
    {
        $this->myPDOBouteille = new MyPDO($_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['password'], 'Bouteille');
    }

    public function count(){
        return $this->myPDOBouteille->count();
    }

    public function current(){
        return $this->myPDOBouteille->get("id_bouteille",$this->id_bouteille);
    }

    public function key(){
        return $this->id_bouteille;
    }

    public function next(){
        $val = $this->myPDOBouteille->get("id_bouteille",0);
        $this->id_bouteille++;
        if( $this->id_bouteille < $this->myPDOBouteille->getMax("id_bouteille") && $this->myPDOBouteille->get("id_bouteille",$this->id_bouteille) == $val )
            $this->next();  
    }

    public function rewind(){
        $this->id_bouteille = 1;
    }

    public function valid(){
        return $this->id_bouteille > 0 && $this->id_bouteille <= $this->myPDOBouteille->getMax("id_bouteille");
    }
}
?>