<?php

    include "../Tables/Categorie.php";
    include "../MyPDO.php";
    include "../bdd.php";

class CategorieIterator implements Iterator, Countable {
    protected $id_categorie = 1;
    private MyPDO $myPDOCategorie;

    public function __construct()
    {
        $this->myPDOCategorie = new MyPDO($_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['password'], 'Categorie');
    }

    public function count(){
        return $this->myPDOCategorie->count();
    }

    public function current(){
        return $this->myPDOCategorie->get("id_Categorie",$this->id_Categorie);
    }

    public function key(){
        return $this->id_Categorie;
    }

    public function next(){
        $val = $this->myPDOCategorie->get("id_Categorie",0);
        $this->id_Categorie++;
        if( $this->id_Categorie < $this->myPDOCategorie->getMax("id_Categorie") && $this->myPDOCategorie->get("id_Categorie",$this->id_Categorie) == $val )
            $this->next();  
    }

    public function rewind(){
        $this->id_Categorie = 1;
    }

    public function valid(){
        return $this->id_Categorie > 0 && $this->id_Categorie <= $this->myPDOCategorie->getMax("id_Categorie");
    }
}
?>