<?php

class VueBouteille
{

/**
  * production d'une string contenant un tableau HTML représentant une bouteille
  * @param Bouteille $bouteille
  * @return string
  */
    public function getHTML4Bouteille(Bouteille $bouteille): string
    {
        $ch = "<table border='1'>
        <tr><th>id_bouteille</th><th>nom_bouteille</th>
            <th>volume_bouteille</th><th>millesime_bouteille</th>
            <th>prix_bouteille</th><th>id_categorie</th>
            <th>id_appellation</th></tr><tr>\n";
        $ch .= "<tr><td>" . $bouteille->getId_Bouteille() . "</td>\n";
        $ch .= "<td>" . $bouteille->getNom_bouteille() . "</td>\n";
        $ch .= "<td>" . $bouteille->getVolume_bouteille() . "</td>\n";
        $ch .= "<td>" . $bouteille->getMillesime_bouteille() . "</td>\n";
        $ch .= "<td>" . $bouteille->getPrix_bouteille() . "</td>\n";
        $ch .= "<td>" . $bouteille->getId_categorie() . "</td>\n";
        $ch .= "<td>" . $bouteille->getId_appellation() . "</td>\n";
        $ch.= "</tr></table>\n";
        return $ch;
    }

    /**
     * production d'une string contenant un formulaire HTML 
     * destiné à saisir une nouvelle bouteille ou à modifier une bouteille existante
     * @param array $assoc
     * @return string
        */
    public function getFormulaire4Bouteille(array $assoc): string
    {
        $ch = "<form action='".$_SERVER['PHP_SELF']."' method='GET'>\n";
        foreach ($assoc as $col => $val) {
            if (is_array($val)) {
                $ch .= "$col : ";

                if($col == "id_bouteille")
                {
                    $ch .= "<input name='$col' type='".$val['type']
                                  ."' value='".$val['default']."' step='any' disabled/>\n";
                    $ch.= "<input type='hidden' name='$col' value='".$val['default']."'/>";
                }
                else
                {
                    $ch .= "<input name='$col' type='".$val['type']
                                  ."' value='".$val['default']."' step='any' />\n";
                }
            }
            else
            {
                $ch .= "$col : <input type='$val' name='$col' step='any'/>\n";
            }
                
        }
        $ch .= "<input type='submit' name='Valider' value='Sauver'/>\n";


        return $ch."</form>\n";
    }

/**
     * production d'une string contenant une liste HTML représentant un ensemble de bouteilles
     * et permettant de les modifier ou de les supprimer grace à un lien hypertexte
     * @param Bouteille $tabBouteille un tableau d'instances de bouteilles
     * @return string
        */
    public function getAllBouteille(array $tabBouteille): string
    {
        $ch = "<ul>\n";
        foreach ($tabBouteille as $bouteille) {
            if ($bouteille instanceof Bouteille) {
                $ch .= "<li>".$bouteille->getId_Bouteille()." ";
                $ch .= $bouteille->getNom_bouteille()." ";
                $ch .= $bouteille->getVolume_bouteille()." ";
                $ch .= $bouteille->getMillesime_bouteille()." ";
                $ch .= $bouteille->getPrix_bouteille()." ";
                $ch .= $bouteille->getId_categorie()." ";
                $ch .= $bouteille->getId_appellation()." ";
                $ch .= "<a href='?action=update&id_bouteille=".$bouteille->getId_Bouteille()."'>Modifier</a> ";
                $ch .= "<a href='?action=delete&id_bouteille=".$bouteille->getId_Bouteille()."'>Supprimer</a> ";
                $ch .= "</li>\n";
            }
        }
        return $ch."</ul>\n";
    }
}

?>